<?php
namespace Teknisa\CMP\Modules\Solicitacao\Modules\SolicitacaoCompras\Controllers;

use Zeedhi\Framework\DataSource\ParameterBag;
use Zeedhi\Framework\DTO;
use Zeedhi\Framework\DTO\Response\Error;
use Zeedhi\Framework\DataSource\DataSet;

class Cmp09500AcompanhamentoSolicitacaoComprasController extends \Teknisa\GER\Controllers\TeknisaCrud {

    protected $dataSourceName = "item_soli";
    protected $connection;

	public function __construct($crudService, ParameterBag $parameterBag, $connection) 
	{
        $this->crudService = $crudService;
        $this->parameterBag = $parameterBag;
        $this->connection = $connection;
    }
    
    public function completaProd($campo)
    {
        return str_pad($campo, 20, 'Z', STR_PAD_RIGHT);
    }
    
    public function filtrarItens(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            $sql = "SELECT DISTINCT CASE ITEM_SOLI.IDSOLIAPROV WHEN 'N' THEN 'A' ELSE( CASE NVL(C.NRCOMPRA,'0') WHEN '0' THEN 'B' ELSE ( CASE NVL(ITEM_AF.NRAUTOFORN,'0') WHEN '0' THEN 'C' ELSE ( CASE NVL(ITEM_AF.IDBAIXITMAF,'0') WHEN '0' THEN 'D' ELSE ITEM_AF.IDBAIXITMAF END) END ) END ) END STATUS, ITEM_SOLI.NRSOLICMP, ITEM_SOLI.CDOPERLANC, MIN(ITEM_SOLI.DTHRLANCSOL) DTHRLANCSOL, DS.NMDESTSOLI, ITEM_SOLI.NRCOMPRA, O.NMOPERADOR, ITEM_SOLI.DTPROGENTR, SUM(ITEM_SOLI.QTSOLIPROD) QTSOLIPROD, MIN(ITEM_AF.NRAUTOFORN) NRAUTOFORN, MIN(ITEM_AF.DTAUTOFORN) DTAUTOFORN, ITEM_NF.CDOPERAPRO, SUM(ITEM_AF.QTEFETENTRAF * P.VRFATOCONV) QTEFETENTRAF, C.DTCONCOLEPREC, ITEM_SOLI.CDFILLAN, ITEM_SOLI.CDDESTSOLI, C.NRCOLEPRECO, C.CDFILIAL, ITEM_NF.DTEMISSAO, ITEM_AF.DTPROGENTAF, ITEMSOLI.NRORG FROM DESTSOL DS, DESTFILI DF, FILIAL F, PRODUTO P, OPERADOR O, COLETAPR C, ITEMSOLI, ( SELECT IA.CDFILDEST, IA.CDFILLANC, IA.NRAUTOFORN, IA.CDPRODUTO, IA.CDMARCA, IA.DTPROGENTAF, IA.DTENTRITMSOL, IP.NRCOMPRA, IA.QTEFETENTRAF, AF.DTAUTOFORN, IA.IDBAIXITMAF, P.VRFATOCONV FROM ITEMAUTF IA, ITMAPURPREC IP, AUTOFORNE AF, PRODUTO P WHERE IP.NRSEQITMAP = AF.NRSEQAPURAF AND IP.CDFORNITMAP = AF.CDFORNECED AND IP.DTENTRAPUT = IA.DTPROGENTAF AND IP.CDFILIAP = IA.CDFILDEST AND IP.CDPRODITMAP = IA.CDPRODUTO AND IP.CDMARCITMAP = IA.CDMARCA AND IA.CDFILDEST = AF.CDFILDEST AND IA.CDFILLANC = AF.CDFILLANC AND IA.NRAUTOFORN = AF.NRAUTOFORN AND IA.CDPRODUTO = P.CDPRODUTO ) ITEM_AF, ( SELECT IT.CDFILSOLI, IT.CDFILLAN, IT.NRSOLICMP, IT.CDPRODUTO, IT.DTPROGENTR, IT.QTSOLIPROD, PC.NRCOMPRA, S.CDOPERLANC, S.CDDESTSOLI, S.DTHRLANCSOL, IT.IDSOLIAPROV FROM ITEMSOLI IT, PRODCOMPRA PC, SOLICITA S WHERE IT.CDFILSOLI = PC.CDFILSOLI (+) AND IT.CDFILLAN = PC.CDFILLAN (+) AND IT.NRSOLICMP = PC.NRSOLICMP (+) AND IT.CDPRODUTO = PC.CDPRODUTO (+) AND IT.DTPROGENTR = PC.DTPROGENTR (+) AND IT.CDFILLAN = S.CDFILLANCA AND IT.CDFILSOLI = S.CDFILSOLI AND IT.NRSOLICMP = S.NRSOLICMP AND ( ( TRUNC(S.DTHRLANCSOL) BETWEEN :P_DTSOLIINI AND :P_DTSOLIFIN ) OR (:P_TDTSOLI = 'T' ) ) AND ( ( IT.DTPROGENTR BETWEEN :P_DTENTRINI AND :P_DTENTRFIN ) OR (:P_TDTENTR = 'T' ) ) AND :P_CDFILIAL = S.CDFILSOLI AND ( INSTR(:P_NRSOLI,S.NRSOLICMP) > 0 OR (:P_TNRSOLI = 'T' ) ) ) ITEM_SOLI, ( SELECT RELAC.NRAUTOFORN, P.NMOPERADOR CDOPERAPRO, RELAC.CDFILDEST, RELAC.CDFILLANC, RELAC.CDMARCA, RELAC.CDPRODUTO, RELAC.DTPROGENTAF, NF.DTEMISSAO FROM NOTAFISCAL NF, NFRELACAF RELAC, OPERADOR P WHERE NF.NRLANCTONF = RELAC.NRLANCTONF AND NF.CDFILIAL = RELAC.CDFILIAL AND P.CDOPERADOR = NF.CDOPERAPRO ) ITEM_NF WHERE DS.CDDESTSOLI = ITEM_SOLI.CDDESTSOLI AND DS.CDFILIAL = ITEM_SOLI.CDFILSOLI AND DS.CDDESTSOLI = DF.CDDESTFILI AND ITEM_SOLI.CDPRODUTO = P.CDPRODUTO AND ( ( P.CDARVPROD BETWEEN :P_CDPRODINI AND :P_CDPRODFIN ) OR (:P_TCDPROD = 'T' ) ) AND ITEM_AF.CDPRODUTO (+) = ITEM_SOLI.CDPRODUTO AND ITEM_AF.DTENTRITMSOL (+) = ITEM_SOLI.DTPROGENTR AND ITEM_AF.NRCOMPRA (+) = ITEM_SOLI.NRCOMPRA AND C.NRCOMPRA (+) = ITEM_SOLI.NRCOMPRA AND ITEM_NF.CDFILDEST (+) = ITEM_AF.CDFILDEST AND ITEM_NF.CDFILLANC (+) = ITEM_AF.CDFILLANC AND ITEM_NF.NRAUTOFORN (+) = ITEM_AF.NRAUTOFORN AND ITEM_NF.CDMARCA (+) = ITEM_AF.CDMARCA AND ITEM_NF.CDPRODUTO (+) = ITEM_AF.CDPRODUTO AND ITEM_NF.DTPROGENTAF (+) = ITEM_AF.DTPROGENTAF AND ITEM_SOLI.CDFILSOLI = F.CDFILIAL AND ITEM_SOLI.CDOPERLANC = O.CDOPERADOR GROUP BY CASE ITEM_SOLI.IDSOLIAPROV WHEN 'N' THEN 'A' ELSE ( CASE NVL(C.NRCOMPRA,'0') WHEN '0' THEN 'B' ELSE ( CASE NVL(ITEM_AF.NRAUTOFORN,'0') WHEN '0' THEN 'C' ELSE ( CASE NVL(ITEM_AF.IDBAIXITMAF,'0') WHEN '0' THEN 'D' ELSE ITEM_AF.IDBAIXITMAF END ) END ) END ) END, ITEM_SOLI.NRSOLICMP, ITEM_SOLI.CDOPERLANC, DS.NMDESTSOLI, ITEM_SOLI.NRCOMPRA, O.NMOPERADOR, ITEM_SOLI.DTPROGENTR, ITEM_NF.CDOPERAPRO, C.DTCONCOLEPREC, ITEM_SOLI.CDFILLAN, ITEM_SOLI.CDDESTSOLI, C.NRCOLEPRECO, C.CDFILIAL, ITEM_NF.DTEMISSAO, ITEM_AF.DTPROGENTAF, ITEMSOLI.NRORG ORDER BY ITEM_SOLI.CDFILLAN, ITEM_SOLI.NRSOLICMP";
            $params = array(
                "P_DTSOLIINI" => $row["P_DTSOLIINI"],
                "P_DTSOLIFIN" => $row["P_DTSOLIFIN"],
                "P_TDTSOLI"   => $row["P_TDTSOLI"]  ,
                "P_DTENTRINI" => $row["P_DTENTRINI"],
                "P_DTENTRFIN" => $row["P_DTENTRFIN"],
                "P_TDTENTR"   => $row["P_TDTENTR"]  ,
                "P_CDFILIAL"  => $row["P_CDFILIAL"] ,
                "P_NRSOLI"    => $row["P_NRSOLI"]   ,
                "P_TNRSOLI"   => $row["P_TNRSOLI"]  ,
                "P_CDPRODINI" => $row["P_CDPRODINI"],
                "P_CDPRODFIN" => $row["P_CDPRODFIN"] = self::completaProd($row['P_CDPRODFIN']),
                "P_TCDPROD"   => $row["P_TCDPROD"]  
            );
            $stmt = $this->connection->prepare($sql);
            $stmt->execute($params);
            $response->addDataSet(new DataSet("item_soli", $stmt->fetchAll()));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
    public function filtrarDetalhes(DTO\Request $request, DTO\Response $response) {
        try {
            $row = $request->getRow();
            
            $sql = "SELECT NVL(APROVACAO.IDAPROVPRGER, 'N') IDAPROVPRGER, DESTSOLGERE.CDDESTSOLI, OPERADOR.NMOPERADOR, APROVACAO.DTAPRSOLPRODGER FROM DESTSOLGERE,(SELECT MAX(APROVSOLPRODGER.IDAPROVPRGER) IDAPROVPRGER, APROVSOLPRODGER.CDOPERADOR, SOLICITA.CDDESTSOLI, APROVSOLPRODGER.DTAPRSOLPRODGER FROM APROVSOLPRODGER, SOLICITA WHERE SOLICITA.CDFILLANCA = APROVSOLPRODGER.CDFILLANCA(+) AND SOLICITA.CDFILSOLI = APROVSOLPRODGER.CDFILSOLI(+) AND SOLICITA.NRSOLICMP = APROVSOLPRODGER.NRSOLICMP(+) AND SOLICITA.CDFILLANCA = :P_CDFILLAN AND SOLICITA.CDFILSOLI = :P_CDFILSOLI AND SOLICITA.NRSOLICMP = :P_NRSOLICMP GROUP BY APROVSOLPRODGER.CDOPERADOR, SOLICITA.CDDESTSOLI, APROVSOLPRODGER.DTAPRSOLPRODGER) APROVACAO, OPERADOR WHERE DESTSOLGERE.CDDESTSOLI = APROVACAO.CDDESTSOLI(+) AND DESTSOLGERE.CDOPERADOR = APROVACAO.CDOPERADOR(+) AND DESTSOLGERE.CDDESTSOLI = :P_CDDESTSOLI AND DESTSOLGERE.CDFILIAL = :P_CDFILSOLI AND OPERADOR.CDOPERADOR = DESTSOLGERE.CDOPERADOR ORDER BY IDAPROVPRGER DESC, OPERADOR.NMOPERADOR";
            $params = array(
                "P_CDFILLAN"   => $row["CDFILLAN"],
                "P_CDFILSOLI"  => $row["CDFILSOLI"],
                "P_NRSOLICMP"  => $row["NRSOLICMP"],
                "P_CDDESTSOLI" => $row["CDDESTSOLI"]
            );
            $stmt = $this->connection->prepare($sql);
            $stmt->execute($params);
            $response->addDataSet(new DataSet("detalhes", $stmt->fetchAll()));
        } catch (\Exception $e) {
            $response->setError(new DTO\Response\Error($e->getMessage(), $e->getCode()));
        }
    }
    
}