/* Sistemas Integrados TEKNISA
   Compras e Suprimentos

Nome: 8140_SUPTRGS_APAGA_CUSTO.SQL

Descrio:
Apagar pr-custo de cotao no disponibilizada para lista de preos.

Criao:
29/06/2005 Marcelo Alexsandro Souza Silva
*/

IF EXISTS (SELECT * FROM sysobjects O, sysusers U
           WHERE
            o.name = 'APAGA_CUSTO'  and
            type = 'TR'             and
            u.uid = o.uid           and
            u.name = USER)

   DROP TRIGGER APAGA_CUSTO;
GO

CREATE TRIGGER APAGA_CUSTO
ON COLETAPR
FOR UPDATE
AS
DECLARE @V_CDFILIAL       VARCHAR(4);
DECLARE @V_NRCOLEPRECO    VARCHAR(10);
DECLARE @V_IDDISMONTLIS_OLD   VARCHAR(1);
DECLARE @V_IDDISMONTLIS_NEW   VARCHAR(1);
DECLARE @V_CDFORNECED     VARCHAR(21);
DECLARE @V_CDREGIAO       VARCHAR(3);
DECLARE @V_CDPRODUTO      VARCHAR(10);
DECLARE @V_CDMARCA        VARCHAR(5);
BEGIN
   SET @V_CDFILIAL         = NULL;
   SET @V_NRCOLEPRECO      = NULL;
   SET @V_IDDISMONTLIS_OLD = NULL;
   SET @V_IDDISMONTLIS_NEW = NULL;
   SET @V_CDFORNECED       = NULL;
   SET @V_CDREGIAO         = NULL;
   SET @V_CDPRODUTO        = NULL;
   SET @V_CDMARCA          = NULL;
   SELECT
      @V_CDFILIAL         = INSERTED.CDFILIAL ,
      @V_NRCOLEPRECO      = INSERTED.NRCOLEPRECO,
      @V_IDDISMONTLIS_NEW = INSERTED.IDDISMONTLIS,
      @V_IDDISMONTLIS_OLD = DELETED.IDDISMONTLIS
   FROM
      INSERTED,
      DELETED
   WHERE
      INSERTED.CDFILIAL    = DELETED.CDFILIAL AND
      INSERTED.NRCOLEPRECO = DELETED.NRCOLEPRECO;
   IF ISNULL(@V_IDDISMONTLIS_NEW, 'S') <> ISNULL(@V_IDDISMONTLIS_OLD, 'S') BEGIN
      IF ISNULL(@V_IDDISMONTLIS_NEW, 'S') = 'N' BEGIN
         DECLARE C_COTACAO CURSOR FOR
            SELECT
                ITEMCOLE.CDFORNECED,
                ITEMCOLE.CDREGIAO,
                ITEMCOLE.CDPRODUTO,
                ITEMCOLE.CDMARCA
             FROM
                ITEMCOLE
             WHERE
                ITEMCOLE.CDFILIAL    = @V_CDFILIAL AND
                ITEMCOLE.NRCOLEPRECO = @V_NRCOLEPRECO
         OPEN C_COTACAO;
         FETCH NEXT FROM C_COTACAO INTO @V_CDFORNECED,
                                        @V_CDREGIAO,
                                        @V_CDPRODUTO,
                                        @V_CDMARCA;
         WHILE (@@FETCH_STATUS = 0) BEGIN
            DELETE FROM
               CUSTOSUP
            WHERE
               CUSTOSUP.CDFILCOTLIST = @V_CDFILIAL     AND
               CUSTOSUP.NRCOLEPRLIST = @V_NRCOLEPRECO  AND
               CUSTOSUP.CDMARCALIST  = @V_CDMARCA      AND
               CUSTOSUP.CDREGIAOLIST = @V_CDREGIAO     AND
               CUSTOSUP.CDFORNECLIST = @V_CDFORNECED   AND
               CUSTOSUP.CDPRODLIST   = @V_CDPRODUTO    AND
               CUSTOSUP.VRPRCUSTOAF IS NULL            AND
               CUSTOSUP.NRCOLEPRACOR IS NULL;
            IF @@ROWCOUNT = 0 BEGIN
               UPDATE CUSTOSUP
               SET
                  VRHISPRLISTP = NULL,
                  VRCUSPRLISTP = NULL,
                  VRCUSPRLISM1 = NULL,
                  VRCUSPRLISM2 = NULL,
                  CDFILCOTLIST = NULL,
                  NRCOLEPRLIST = NULL,
                  CDMARCALIST  = NULL,
                  CDREGIAOLIST = NULL,
                  CDFORNECLIST = NULL,
                  CDPRODLIST   = NULL
               WHERE                      
                  CUSTOSUP.CDFILCOTLIST = @V_CDFILIAL     AND
                  CUSTOSUP.NRCOLEPRLIST = @V_NRCOLEPRECO  AND
                  CUSTOSUP.CDMARCALIST  = @V_CDMARCA      AND
                  CUSTOSUP.CDREGIAOLIST = @V_CDREGIAO     AND
                  CUSTOSUP.CDFORNECLIST = @V_CDFORNECED   AND
                  CUSTOSUP.CDPRODLIST   = @V_CDPRODUTO    AND
                  CUSTOSUP.NRCOLEPRACOR IS NULL;
            END;
            FETCH NEXT FROM C_COTACAO INTO @V_CDFORNECED,
                                           @V_CDREGIAO,
                                           @V_CDPRODUTO,
                                           @V_CDMARCA;
         END;
         CLOSE C_COTACAO;
         DEALLOCATE C_COTACAO;
      END;
   END;
END;
GO
