function SolicitacaoComprasService(restEngine) {
    this.save = function (currentRow) {
        delete currentRow.__rightActions;
        delete currentRow.__leftActions;
        if(typeof currentRow.CDFILLAN === 'undefined')
            currentRow.CDFILLAN = getLocalVar('CDFILIAL');
        if(typeof currentRow.CDFILSOLI === 'undefined')
            currentRow.CDFILSOLI = getLocalVar('CDFILIAL');
        return restEngine.post("cmp_V1#/solicitacao_compras_justificativa/save",
            {
                "requestType": "Row",
                "row": currentRow
            }
        );
    };
    this.delete = function (currentRow) {
        delete currentRow.__rightActions;
        delete currentRow.__leftActions;
        return restEngine.post("cmp_V1#/solicitacao_compras_justificativa/remove",
            {
                "requestType": "Row",
                "row": currentRow
            }
        );
    };

    this.getRegras = function () {
        return restEngine.post("cmp_V1#/solicitacao_compras_regras",
            {
                "requestType": "FilterData"
            }
        );
    };
    this.getItemSoli = function (filterArray) {
        return restEngine.post("cmp_V1#/solicitacao_compras_justificativa",
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "DTPROGENTR",
                        "operator": "=",
                        "value": filterArray.DTPROGENTR
                    },
                    {
                        "name": "CDPRODUTO",
                        "operator": "=",
                        "value": filterArray.CDPRODUTO
                    },
                    {
                        "name": "CDFILLAN",
                        "operator": "=",
                        "value": filterArray.CDFILLAN
                    },
                    {
                        "name": "IDTIPLAN",
                        "operator": "=",
                        "value": filterArray.IDTIPLAN
                    },
                    {
                        "name": "CDDESTSOLI",
                        "operator": filterArray.CDDESTSOLI ? "=" : "IS_NULL",
                        "value": filterArray.CDDESTSOLI ? filterArray.CDDESTSOLI : ""
                    },
                    {
                        "name": "CDCOMPRADOR",
                        "operator": filterArray.CDCOMPRADOR ? "=" : "IS_NULL",
                        "value": filterArray.CDCOMPRADOR ? filterArray.CDCOMPRADOR : ""
                    }
                ]
            }
        );
    };
    this.getFilialData = function (cdFilial, nrorg) {
        return restEngine.post("cmp_V1#/cmp_V1_filial",
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "CDFILIAL",
                        "operator": "=",
                        "value": cdFilial
                    },
                    {
                        "name": "NRORG",
                        "operator": "=",
                        "value": nrorg
                    }
                ]
            }
        );
    };
    this.getPeriodicidade = function (filterArray) {
        return restEngine.post("cmp_V1#/periodicidade",
            {
                "requestType": "FilterData",
                "filter": [
                    {
                        "name": "DTPROGENTR",
                        "operator": "=",
                        "value": filterArray.DTPROGENTR
                    },
                    {
                        "name": "CDPRODUTO",
                        "operator": "=",
                        "value": filterArray.CDPRODUTO
                    }
                ]
            }
        );
    };
}

Configuration(function (ContextRegister) {
    ContextRegister.register('SolicitacaoComprasService', SolicitacaoComprasService);
});